



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android应用如何支持屏幕多尺寸多分辨率问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android应用如何支持屏幕多尺寸多分辨率问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 15:29:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>作为Android应用程序开发者都知道android是一个&ldquo;碎片化&rdquo;的世界。多种系统版本、多种尺寸、多种分辨率、多种机型,还有不同的厂商定制的不同ROM，你开发的应用会在不可预期的手机上报错。这给开发适配带来不小的难度。这篇文章会告诉我们怎么解决这个问题。</p>
<h2>1、Android碎片化</h2>
<div>
<h3>1.1、android系统版本</h3>
<p>Android更新较大的版本如下：</p>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140730175422671" /></div>
<div>&nbsp;</div>
<p>上面只有当前可用版本，Android L作为开发者版本没有出现其中，未来会有更多的版本。下图给出Android各个版本的占有率，这个是googleplay统计的近期数据。googleplay只支持2.2以上的手机，所以统计中缺少2.2以下版本。</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140730180244051" /></p>
<h3>1.2、Android中不同尺寸、不同分辨率市场占有情况</h3>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140730180304175" /></p>
<h3>3、Android不同机型</h3>
<p>这是OpenSignal在2013年的调查调查结果，Android系统设备覆盖了11,868不同机型，现在肯定会更多。</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140730180338183" /></p>
<h2>2、基本概念</h2>
</div>
<p>Android&ldquo;碎片化&rdquo;如此严重，那么我们怎么解决Android应用适配问题呢。Android官方文档给出了解决方案，这篇文章也是参考总结的官方文档。</p>
<p>解决Android&ldquo;碎片化&rdquo;化问题，我们需要了解一些基础概念。</p>
<p><strong>屏幕大小</strong></p>
<p>根据屏幕对角线实际测量的物理大小（android已经根据屏幕大小分为四类small, normal, large, extra large），具体怎么划分的下面会提到。</p>
<p><strong>屏幕密度</strong><br />&nbsp; &nbsp; 屏幕物理区域一个单位（一般用英寸）的像素数量，一般简称dpi（dots per inch，每英寸上的点数，记住DPI这个概念很重要）屏幕密度也分为四类 low, medium, high, extra high，他们的比例关系是 0.75:1:1.5:2，具体的值为120:160:240:320。</p>
<p><strong>屏幕方向<br /></strong>&nbsp; &nbsp; 屏幕方向分为横屏和竖屏。</p>
<p><strong>分辨率<br /></strong>&nbsp; &nbsp; 一个物理屏幕上像素点的总数。一般我们的App不会直接使用分辨率，而是使用密度和屏幕大小。</p>
<p><strong>独立像素单位（Density-independent pixel (dp)）<br /></strong>&nbsp; &nbsp; 一个虚拟的单位，用来决定UI布局的。用来表述布局的尺寸或者位置。<br />&nbsp; &nbsp; dp是一个与屏幕密度有关系的单位，dp与像素的换算关系为&nbsp;px = dp * (dpi / 160)。例如在240密度（dpi）的屏幕上一个dp等于1.5个像素。以后我们应该尽量使用dp单位布局，不要使用像素单位。这样会使你的app屏幕兼容性更好</p>
<p>Android1.6开始就支持多屏幕和密度了，这都是为了更好的用户体验，为了简化我们多屏幕的开发，当然这要声明&lt;uses-sdk android:minSdkVersion="4" /&gt;或者大于4。android提供了一组范围让我们使用，见下图：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140730181048198" /></p>
<h2>3、Android中资源配置</h2>
<div>&nbsp;</div>
<p>Android工程中经常看到下图的资源文件配置，一般会包含animator、anim、color、drawable、layout、menu、raw、value、xml等。</p>
<p>命名规则是<em>&lt;resources_name&gt;</em>-<em>&lt;config_qualifier&gt;。<br /></em>&nbsp; &nbsp; &lt;resources_name&gt;：资源文件名<br /><em>&nbsp; &nbsp; &lt;config_qualifier&gt;：特定条件下可以使用这种资源</em></p>
<p><em>&nbsp;</em></p>
<div><em><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140730181319596" /><br /></em></div>
<div><em>&nbsp;</em></div>
<p><em>config_qualifier可以使用多种：</em></p>
<p><em>&nbsp;</em></p>
<table>
<tbody>
<tr>
<td>Configuration</td>
<td>Qualifier Values</td>
<td>Description</td>
</tr>
<tr>
<td>MCC and MNC</td>
<td>Examples:mcc310mcc310-mnc004mcc208-mnc00etc.</td>
<td>The mobile country code (MCC), optionally followed by mobile network code (MNC) from the SIM card in the device. For example,&nbsp;mcc310&nbsp;is U.S. on any carrier,mcc310-mnc004&nbsp;is U.S. on Verizon, and&nbsp;mcc208-mnc00&nbsp;is France on Orange.<br />If the device uses a radio connection (GSM phone), the MCC and MNC values come from the SIM card.<br />You can also use the MCC alone (for example, to include country-specific legal resources in your application). If you need to specify based on the language only, then use the&nbsp;<em>language and region</em>&nbsp;qualifier instead (discussed next). If you decide to use the MCC and MNC qualifier, you should do so with care and test that it works as expected.<br />Also see the configuration fields&nbsp;mcc, and&nbsp;mnc, which indicate the current mobile country code and mobile network code, respectively.</td>
</tr>
<tr>
<td>Language and region</td>
<td>Examples:enfren-rUSfr-rFRfr-rCAetc.</td>
<td>The language is defined by a two-letter&nbsp;ISO 639-1&nbsp;language code, optionally followed by a two letter&nbsp;ISO 3166-1-alpha-2&nbsp;region code (preceded by lowercase "r").<br />The codes are&nbsp;<em>not</em>&nbsp;case-sensitive; the&nbsp;r&nbsp;prefix is used to distinguish the region portion. You cannot specify a region alone.<br />This can change during the life of your application if the user changes his or her language in the system settings. See&nbsp;Handling Runtime Changes&nbsp;for information about how this can affect your application during runtime.<br />See&nbsp;Localization&nbsp;for a complete guide to localizing your application for other languages.<br />Also see the&nbsp;locale&nbsp;configuration field, which indicates the current locale.</td>
</tr>
<tr>
<td>Layout Direction</td>
<td>ldrtlldltr</td>
<td>The layout direction of your application.&nbsp;ldrtl&nbsp;means "layout-direction-right-to-left".&nbsp;ldltr&nbsp;means "layout-direction-left-to-right" and is the default implicit value.<br />This can apply to any resource such as layouts, drawables, or values.<br />For example, if you want to provide some specific layout for the Arabic language and some generic layout for any other "right-to-left" language (like Persian or Hebrew) then you would have:<br />res/<br />&nbsp;&nbsp;&nbsp; layout/&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; main.xml&nbsp; (Default layout)<br />&nbsp;&nbsp;&nbsp; layout-ar/&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; main.xml&nbsp; (Specific layout for Arabic)<br />&nbsp;&nbsp;&nbsp; layout-ldrtl/&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; main.xml&nbsp; (Any "right-to-left" language, except<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; for Arabic, because the "ar" language qualifier<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; has a higher precedence.)</p>
<p><strong>Note:</strong>&nbsp;To enable right-to-left layout features for your app, you must setsupportsRtl&nbsp;to&nbsp;"true"&nbsp;and set&nbsp;targetSdkVersion&nbsp;to 17 or higher.<br /><em>Added in API level 17.</em></td>
</tr>
<tr>
<td>smallestWidth</td>
<td>sw&lt;N&gt;dpExamples:sw320dpsw600dpsw720dpetc.</td>
<td>The fundamental size of a screen, as indicated by the shortest dimension of the available screen area. Specifically, the device's smallestWidth is the shortest of the screen's available height and width (you may also think of it as the "smallest possible width" for the screen). You can use this qualifier to ensure that, regardless of the screen's current orientation, your application has at least&nbsp;&lt;N&gt;&nbsp;dps of width available for its UI.<br />For example, if your layout requires that its smallest dimension of screen area be at least 600 dp at all times, then you can use this qualifer to create the layout resources,&nbsp;res/layout-sw600dp/. The system will use these resources only when the smallest dimension of available screen is at least 600dp, regardless of whether the 600dp side is the user-perceived height or width. The smallestWidth is a fixed screen size characteristic of the device;&nbsp;<strong>the device's smallestWidth does not change when the screen's orientation changes</strong>.<br />The smallestWidth of a device takes into account screen decorations and system UI. For example, if the device has some persistent UI elements on the screen that account for space along the axis of the smallestWidth, the system declares the smallestWidth to be smaller than the actual screen size, because those are screen pixels not available for your UI. Thus, the value you use should be the actual smallest dimension&nbsp;<em>required by your layout</em>&nbsp;(usually, this value is the "smallest width" that your layout supports, regardless of the screen's current orientation).<br />Some values you might use here for common screen sizes:<br />320, for devices with screen configurations such as:<br />240x320 ldpi (QVGA handset)<br />320x480 mdpi (handset)<br />480x800 hdpi (high density handset)<br />480, for screens such as 480x800 mdpi (tablet/handset).<br />600, for screens such as 600x1024 mdpi (7" tablet).<br />720, for screens such as 720x1280 mdpi (10" tablet).<br />When your application provides multiple resource directories with different values for the smallestWidth qualifier, the system uses the one closest to (without exceeding) the device's smallestWidth.<br /><em>Added in API level 13.</em><br />Also see the&nbsp;android:requiresSmallestWidthDp&nbsp;attribute, which declares the minimum smallestWidth with which your application is compatible, and thesmallestScreenWidthDp&nbsp;configuration field, which holds the device's smallestWidth value.<br />For more information about designing for different screens and using this qualifier, see the&nbsp;Supporting Multiple Screens&nbsp;developer guide.</td>
</tr>
<tr>
<td>Available width</td>
<td>w&lt;N&gt;dpExamples:w720dpw1024dpetc.</td>
<td>Specifies a minimum available screen width, in&nbsp;dp&nbsp;units at which the resource should be used&mdash;defined by the&nbsp;&lt;N&gt;&nbsp;value. This configuration value will change when the orientation changes between landscape and portrait to match the current actual width.<br />When your application provides multiple resource directories with different values for this configuration, the system uses the one closest to (without exceeding) the device's current screen width. The value here takes into account screen decorations, so if the device has some persistent UI elements on the left or right edge of the display, it uses a value for the width that is smaller than the real screen size, accounting for these UI elements and reducing the application's available space.<br /><em>Added in API level 13.</em><br />Also see the&nbsp;screenWidthDp&nbsp;configuration field, which holds the current screen width.<br />For more information about designing for different screens and using this qualifier, see the&nbsp;Supporting Multiple Screens&nbsp;developer guide.</td>
</tr>
<tr>
<td>Available height</td>
<td>h&lt;N&gt;dpExamples:h720dph1024dpetc.</td>
<td>Specifies a minimum available screen height, in "dp" units at which the resource should be used&mdash;defined by the&nbsp;&lt;N&gt;&nbsp;value. This configuration value will change when the orientation changes between landscape and portrait to match the current actual height.<br />When your application provides multiple resource directories with different values for this configuration, the system uses the one closest to (without exceeding) the device's current screen height. The value here takes into account screen decorations, so if the device has some persistent UI elements on the top or bottom edge of the display, it uses a value for the height that is smaller than the real screen size, accounting for these UI elements and reducing the application's available space. Screen decorations that are not fixed (such as a phone status bar that can be hidden when full screen) are&nbsp;<em>not</em>&nbsp;accounted for here, nor are window decorations like the title bar or action bar, so applications must be prepared to deal with a somewhat smaller space than they specify.<br /><em>Added in API level 13.</em><br />Also see the&nbsp;screenHeightDp&nbsp;configuration field, which holds the current screen width.<br />For more information about designing for different screens and using this qualifier, see the&nbsp;Supporting Multiple Screens&nbsp;developer guide.</td>
</tr>
<tr>
<td>Screen size</td>
<td>smallnormallargexlarge</td>
<td>small: Screens that are of similar size to a low-density QVGA screen. The minimum layout size for a small screen is approximately 320x426 dp units. Examples are QVGA low density and VGA high density.<br />normal: Screens that are of similar size to a medium-density HVGA screen. The minimum layout size for a normal screen is approximately 320x470 dp units. Examples of such screens a WQVGA low density, HVGA medium density, WVGA high density.<br />large: Screens that are of similar size to a medium-density VGA screen. The minimum layout size for a large screen is approximately 480x640 dp units. Examples are VGA and WVGA medium density screens.<br />xlarge: Screens that are considerably larger than the traditional medium-density HVGA screen. The minimum layout size for an xlarge screen is approximately 720x960 dp units. In most cases, devices with extra large screens would be too large to carry in a pocket and would most likely be tablet-style devices.&nbsp;<em>Added in API level 9.</em><br /><strong>Note:</strong>&nbsp;Using a size qualifier does not imply that the resources are&nbsp;<em>only</em>&nbsp;for screens of that size. If you do not provide alternative resources with qualifiers that better match the current device configuration, the system may use whichever resources are the&nbsp;best match.<br /><strong>Caution:</strong>&nbsp;If all your resources use a size qualifier that is&nbsp;<em>larger</em>&nbsp;than the current screen, the system will&nbsp;<strong>not</strong>&nbsp;use them and your application will crash at runtime (for example, if all layout resources are tagged with the&nbsp;xlarge&nbsp;qualifier, but the device is a normal-size screen).<br /><em>Added in API level 4.</em><br />See&nbsp;Supporting Multiple Screens&nbsp;for more information.<br />Also see the&nbsp;screenLayout&nbsp;configuration field, which indicates whether the screen is small, normal, or large.</td>
</tr>
<tr>
<td>Screen aspect</td>
<td>longnotlong</td>
<td>long: Long screens, such as WQVGA, WVGA, FWVGA<br />notlong: Not long screens, such as QVGA, HVGA, and VGA<br /><em>Added in API level 4.</em><br />This is based purely on the aspect ratio of the screen (a "long" screen is wider). This is not related to the screen orientation.<br />Also see the&nbsp;screenLayout&nbsp;configuration field, which indicates whether the screen is long.</td>
</tr>
<tr>
<td>Screen orientation</td>
<td>portland</td>
<td>port: Device is in portrait orientation (vertical)<br />land: Device is in landscape orientation (horizontal)<br />This can change during the life of your application if the user rotates the screen. See&nbsp;Handling Runtime Changes&nbsp;for information about how this affects your application during runtime.<br />Also see the&nbsp;orientation&nbsp;configuration field, which indicates the current device orientation.</td>
</tr>
<tr>
<td>UI mode</td>
<td>cardesktelevisionappliancewatch</td>
<td>car: Device is displaying in a car dock<br />desk: Device is displaying in a desk dock<br />television: Device is displaying on a television, providing a "ten foot" experience where its UI is on a large screen that the user is far away from, primarily oriented around DPAD or other non-pointer interaction<br />appliance: Device is serving as an appliance, with no display<br />watch: Device has a display and is worn on the wrist<br /><em>Added in API level 8, television added in API 13, watch added in API 20.</em><br />For information about how your app can respond when the device is inserted into or removed from a dock, read&nbsp;Determining and Monitoring the Docking State and Type.<br />This can change during the life of your application if the user places the device in a dock. You can enable or disable some of these modes using&nbsp;UiModeManager. SeeHandling Runtime Changes&nbsp;for information about how this affects your application during runtime.</td>
</tr>
<tr>
<td>Night mode</td>
<td>nightnotnight</td>
<td>night: Night time<br />notnight: Day time<br /><em>Added in API level 8.</em><br />This can change during the life of your application if night mode is left in auto mode (default), in which case the mode changes based on the time of day. You can enable or disable this mode using&nbsp;UiModeManager. See&nbsp;Handling Runtime Changes&nbsp;for information about how this affects your application during runtime.</td>
</tr>
<tr>
<td>Screen pixel density (dpi)</td>
<td>ldpimdpihdpixhdpinodpitvdpi</td>
<td>ldpi: Low-density screens; approximately 120dpi.<br />mdpi: Medium-density (on traditional HVGA) screens; approximately 160dpi.<br />hdpi: High-density screens; approximately 240dpi.<br />xhdpi: Extra high-density screens; approximately 320dpi.&nbsp;<em>Added in API Level 8</em><br />nodpi: This can be used for bitmap resources that you do not want to be scaled to match the device density.<br />tvdpi: Screens somewhere between mdpi and hdpi; approximately 213dpi. This is not considered a "primary" density group. It is mostly intended for televisions and most apps shouldn't need it&mdash;providing mdpi and hdpi resources is sufficient for most apps and the system will scale them as appropriate. This qualifier was introduced with API level 13.<br />There is a 3:4:6:8 scaling ratio between the four primary densities (ignoring the tvdpi density). So, a 9x9 bitmap in ldpi is 12x12 in mdpi, 18x18 in hdpi and 24x24 in xhdpi.<br />If you decide that your image resources don't look good enough on a television or other certain devices and want to try tvdpi resources, the scaling factor is 1.33*mdpi. For example, a 100px x 100px image for mdpi screens should be 133px x 133px for tvdpi.<br /><strong>Note:</strong>&nbsp;Using a density qualifier does not imply that the resources are&nbsp;<em>only</em>&nbsp;for screens of that density. If you do not provide alternative resources with qualifiers that better match the current device configuration, the system may use whichever resources are the&nbsp;best match.<br />See&nbsp;Supporting Multiple Screens&nbsp;for more information about how to handle different screen densities and how Android might scale your bitmaps to fit the current density.</td>
</tr>
<tr>
<td>Touchscreen type</td>
<td>notouchfinger</td>
<td>notouch: Device does not have a touchscreen.<br />finger: Device has a touchscreen that is intended to be used through direction interaction of the user's finger.<br />Also see the&nbsp;touchscreen&nbsp;configuration field, which indicates the type of touchscreen on the device.</td>
</tr>
<tr>
<td>Keyboard availability</td>
<td>keysexposedkeyshiddenkeyssoft</td>
<td>keysexposed: Device has a keyboard available. If the device has a software keyboard enabled (which is likely), this may be used even when the hardware keyboard is&nbsp;<em>not</em>&nbsp;exposed to the user, even if the device has no hardware keyboard. If no software keyboard is provided or it's disabled, then this is only used when a hardware keyboard is exposed.<br />keyshidden: Device has a hardware keyboard available but it is hidden&nbsp;<em>and</em>&nbsp;the device does&nbsp;<em>not</em>&nbsp;have a software keyboard enabled.<br />keyssoft: Device has a software keyboard enabled, whether it's visible or not.<br />If you provide&nbsp;keysexposed&nbsp;resources, but not&nbsp;keyssoft&nbsp;resources, the system uses the&nbsp;keysexposed&nbsp;resources regardless of whether a keyboard is visible, as long as the system has a software keyboard enabled.<br />This can change during the life of your application if the user opens a hardware keyboard. See&nbsp;Handling Runtime Changes&nbsp;for information about how this affects your application during runtime.<br />Also see the configuration fields&nbsp;hardKeyboardHidden&nbsp;and&nbsp;keyboardHidden, which indicate the visibility of a hardware keyboard and and the visibility of any kind of keyboard (including software), respectively.</td>
</tr>
<tr>
<td>Primary text input method</td>
<td>nokeysqwerty12key</td>
<td>nokeys: Device has no hardware keys for text input.<br />qwerty: Device has a hardware qwerty keyboard, whether it's visible to the user or not.<br />12key: Device has a hardware 12-key keyboard, whether it's visible to the user or not.<br />Also see the&nbsp;keyboard&nbsp;configuration field, which indicates the primary text input method available.</td>
</tr>
<tr>
<td>Navigation key availability</td>
<td>navexposednavhidden</td>
<td>navexposed: Navigation keys are available to the user.<br />navhidden: Navigation keys are not available (such as behind a closed lid).<br />This can change during the life of your application if the user reveals the navigation keys. See&nbsp;Handling Runtime Changes&nbsp;for information about how this affects your application during runtime.<br />Also see the&nbsp;navigationHidden&nbsp;configuration field, which indicates whether navigation keys are hidden.</td>
</tr>
<tr>
<td>Primary non-touch navigation method</td>
<td>nonavdpadtrackballwheel</td>
<td>nonav: Device has no navigation facility other than using the touchscreen.<br />dpad: Device has a directional-pad (d-pad) for navigation.<br />trackball: Device has a trackball for navigation.<br />wheel: Device has a directional wheel(s) for navigation (uncommon).<br />Also see the&nbsp;navigation&nbsp;configuration field, which indicates the type of navigation method available.</td>
</tr>
<tr>
<td>Platform Version (API level)</td>
<td>Examples:v3v4v7etc.</td>
<td>The API level supported by the device. For example,&nbsp;v1&nbsp;for API level 1 (devices with Android 1.0 or higher) and&nbsp;v4&nbsp;for API level 4 (devices with Android 1.6 or higher). See the&nbsp;Android API levels&nbsp;document for more information about these values.</td>
</tr>
</tbody>
</table>
<p><em>&nbsp;</em></p>
<p>资源文件可以配置多种选择条件。<br />Android系统是怎样找到最合适的资源的请参考：</p>
<p><em>http://developer.android.com/guide/topics/resources/providing-resources.html#BestMatch</em></p>
<h2>4、怎么解决这些问题</h2>
<p>其实给出的解决方法也是官方文档中，这里会简单的写一点，有条件可以看一下参考中的链接。</p>
<h3>4.1&nbsp;Supporting Different Devices</h3>
<h4>4.1.1支持不同的语言</h4>
<p>这一点是应用怎么实现国际化，使用values文件添加<em>config_qualifier属性，例如：</em></p>
<p><em>&nbsp;</em></p>
<pre class="prettyprint linenums">MyProject/<br />
    res/<br />
       values/<br />
           strings.xml<br />
       values-es/<br />
           strings.xml<br />
       values-fr/<br />
           strings.xml</pre>
<h4>4.1.2支持不同的屏幕</h4>
<p>Android手机的屏幕有两个属性，屏幕尺寸、屏幕密度。前面也介绍了屏幕的尺寸、密度。解决这个问题，我们需要声明不同的布局，不同的图片资源。屏幕的方向（横屏、竖屏）也是在这处理的。这个和前面国际化处理一样的，使用资源文件添加<em>config_qualifier属性。</em></p>
<h5>4.1.2.1 Create Different Layouts</h5>
<div>Android中一般分为四种尺寸：&nbsp;small, normal, large, xlarge。</div>
<div>&nbsp;</div>
<div>一般创建不同的布局来适配这四种尺寸。</div>
<div>&nbsp;</div>
<p>适配不同尺寸可以创建下面目录：</p>
<pre class="prettyprint linenums">MyProject/<br />
    res/<br />
        layout/<br />
            main.xml<br />
        layout-large/<br />
            main.xml</pre>
<p>适配横屏、竖屏可以创建如下目录：</p>
<pre class="prettyprint linenums">MyProject/<br />
    res/<br />
        layout/<br />
            main.xml<br />
        layout-land/<br />
            main.xml</pre>
<p>如果需要同时适配，需要更多的条件：</p>
<pre class="prettyprint linenums">MyProject/<br />
    res/<br />
        layout/              # default (portrait)<br />
            main.xml<br />
        layout-land/         # landscape<br />
            main.xml<br />
        layout-large/        # large (portrait)<br />
            main.xml<br />
        layout-large-land/   # large landscape<br />
            main.xml</pre>
<h5>Android3.2中为了适配平板的开发，增加了smallestWidth属性。<a href="http://developer.android.com/guide/practices/screens_support.html#DeclaringTabletLayouts" rel="external nofollow noreferrer">详情参考</a>。</h5>
<h5>4.1.2.2&nbsp;Create Different Bitmaps</h5>
<div>&nbsp; &nbsp; Android中图片资源是必不可少的，并且建议提供四种图片以适应不同的屏幕密度。Android中广义的屏幕密度分为4种（&nbsp;low, medium, high and extra-high&nbsp;）。他们的比例关系如下：</div>
<div>&nbsp;</div>
<div>
<pre class="prettyprint linenums">xhdpi: 2.0<br />
hdpi: 1.5<br />
mdpi: 1.0 (baseline)<br />
ldpi: 0.75</pre>
<p>如果你在mdpi中放置200x200的图片，建议你在mdpi中放置100x100的图片。</p>
</div>
<div>&nbsp;</div>
<div>图片资源文件如下：</div>
<div>&nbsp;</div>
<div>
<pre class="prettyprint linenums">MyProject/<br />
    res/<br />
        drawable-xhdpi/<br />
            awesomeimage.png<br />
        drawable-hdpi/<br />
            awesomeimage.png<br />
        drawable-mdpi/<br />
            awesomeimage.png<br />
        drawable-ldpi/<br />
            awesomeimage.png</pre>
</div>
<div>现在已经不建议使用ldpi，因为这样的手机基本没了<img referrerpolicy="no-referrer"src="http://static.blog.csdn.net/xheditor/xheditor_emot/default/laugh.gif" />。</div>
<div>&nbsp;</div>
<h4>4.1.3支持不同的平台版本</h4>
<p>Android版本的升级就会带来新的api，我们怎么适配不同的系统版本呢。</p>
<p>1、使用&nbsp;Android Support Library</p>
<p>2、AndroidManifest文件配置minSdk、targetSdk。</p>
<pre class="prettyprint linenums">&lt;manifest xmlns:android="http://schemas.android.com/apk/res/android" ... &gt;<br />
    &lt;uses-sdk android:minSdkVersion="4" android:targetSdkVersion="15" /&gt;<br />
    ...<br />
&lt;/manifest&gt;</pre>
<p>3、检测版本号，根据版本号调用api</p>
<pre class="prettyprint linenums">private void setUpActionBar() {<br />
    // Make sure we're running on Honeycomb or higher to use ActionBar APIs<br />
    if (Build.VERSION.SDK_INT &gt;= Build.VERSION_CODES.HONEYCOMB) {<br />
        ActionBar actionBar = getActionBar();<br />
        actionBar.setDisplayHomeAsUpEnabled(true);<br />
    }<br />
}</pre>
<p>4、使用平台的Styles and Themes</p>
<pre class="prettyprint linenums">&lt;activity android:theme="@android:style/Theme.Dialog"&gt;</pre>
<pre class="prettyprint linenums">&lt;activity android:theme="@android:style/Theme.Translucent"&gt;</pre>
<h3>4.2&nbsp;Designing for Multiple Screens</h3>
<p>Android设备包含phone、glass、watch、autocar等等，这些屏幕尺寸从小到watch大到电视，我们的应用能够兼容这么多的尺寸是很重要的。</p>
<h4>4.2.1支持不同屏幕尺寸</h4>
<h5>4.2.1.1 Use "wrap_content" and "match_parent"</h5>
<p>UI实现中view和layout的高度、宽度使用"wrap_content" and "match_parent"，不使用固定值。</p>
<h5>4.2.1.2 Use RelativeLayout</h5>
<div>
<p>UI实现中layout尽量使用RelativeLayout，这样可以控制相对位置，还能减少布局的层级。</p>
</div>
<h5>4.2.1.3 Use Size Qualifiers</h5>
<blockquote><p>距离使用dp和字体使用sp作为单位，不使用px。</p></blockquote>
<h5>4.2.1.4 Use the Smallest-width Qualifier</h5>
<blockquote><div>
<p>使用Smallest-width Qualifier，这个是Android3.2开始支持的，以适配平板。</p>
</div>
<div>
<pre class="prettyprint linenums">res/layout-sw600dp/main.xml</pre>
</div></blockquote>
<h5>4.2.1.5 Use Layout Aliases</h5>
<blockquote><p>使用Layout的别名，以适配不同尺寸的屏幕。</p></blockquote>
<h5>4.2.1.6 Use Orientation Qualifiers</h5>
<blockquote><p>使用屏幕方向属性，以支持横屏、竖屏。</p></blockquote>
<h5>4.2.1.7 Use Nine-patch Bitmaps</h5>
<blockquote><p>使用.9图片，.9图片能很好地支持横向、竖向拉伸。</p></blockquote>
<div>&nbsp;</div>
<h4>4.2.2支持不同屏幕密度</h4>
<blockquote><p>见4.1.2.2&nbsp;Create Different Bitmaps</p></blockquote>
<h4>4.2.3创建自适应界面</h4>
<p>这里主要是运行时检测，什么是运行时检测呢，就是在java代码中判断需要的view是否找到（是否为空），例如下面的代码。</p>
<pre class="prettyprint linenums">public class NewsReaderActivity extends FragmentActivity {<br />
    boolean mIsDualPane;

    @Override<br />
    public void onCreate(Bundle savedInstanceState) {<br />
        super.onCreate(savedInstanceState);<br />
        setContentView(R.layout.main_layout);

        View articleView = findViewById(R.id.article);<br />
        mIsDualPane = articleView != null &amp;&amp;<br />
                        articleView.getVisibility() == View.VISIBLE;<br />
    }<br />
}</pre>
<p>这一方面的，可以参考<a href="http://blog.csdn.net/xyz_lmn/article/details/8648008" rel="external nofollow noreferrer">《Android UI开发第三十篇&mdash;&mdash;使用Fragment构建灵活的桌面》</a>。</p>
<p>Android应用如何支持屏幕多尺寸多分辨率问题基本就这些，更多经验需要从实践中总结。</p>
<p>后记：很久的时候和一位小伙伴讨论过应用适配的问题，说好了要总结出来的，现在权当实现诺言，写的有些凌乱，有读不通的通信请留言。</p>
<p>想了解Android历史的同学可以参考</p>
<p>http://arstechnica.com/gadgets/2014/06/building-android-a-40000-word-history-of-googles-mobile-os/</p>
<div>
<div>/**</div>
<div>* @author 张兴业</div>
</div>
<div>
<div>* &nbsp;<a href="http://blog.csdn.net/xyz_lmn" rel="external nofollow noreferrer">http://blog.csdn.net/xyz_lmn</a></div>
<div>* &nbsp;我的新浪微博：<strong><a href="http://weibo.com/xyzlmn" rel="external nofollow noreferrer">@张兴业TBOW</a></strong></div>
<div>*/</div>
</div>
<p>参考：</p>
<p>http://developer.android.com/about/dashboards/index.html<br />http://opensignal.com/reports/fragmentation-2013/<br />http://developer.android.com/guide/practices/screens_support.html<br />http://developer.android.com/guide/topics/resources/providing-resources.html<br />http://developer.android.com/training/basics/supporting-devices/index.html</p>
<p>http://developer.android.com/training/multiscreen/index.html</p>
<p>http://www.androidized.com/a-brief-history-of-android/</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1kzlz9.html">Spark 官方文档（5）&mdash;&mdash;Spark SQL，DataFrames和Datasets 指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1jyk2q.html">RHEL 6&period;0服务器安装Oracle 11G R2 最终版</a>
		</li>
						<li><a href="https://www.batexi.com/a/390y76n8.html">C&num;入门（面向对象概念）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yydm0q.html">datagrid实现单行的选择、取消</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm5wm79.html">小娱乐一下，fileInfo中的Name &comma;FullName的用法小BUG</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjex5y9.html">POJ 3020 Antenna Placement 解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwded538.html">postgresql 字符串拼接&amp;quot&semi;&vert;&vert;&OpenCurlyDoubleQuote;的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jwonl8.html">WebSocket API</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj17319.html">Byte Array to Hexadecimal String</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge36yz8.html">xntp的配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjry3z8.html">刨根究底字符编码之十二&mdash;&mdash;UTF-8究竟是怎么编码的</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzxw0l8.html">小白的Python之路 day5 shutil模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zozlnvq.html">基于Nginx进行地图瓦片缓存的方案描述</a>
		</li>
						<li><a href="https://www.batexi.com/a/q252zmlq.html">Android Studio 好用的设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwgyxy8.html">Go 初体验 - 令人惊叹的语法 - defer&period;2 - 如何提前执行？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zko3v18.html">IntelliJ IDEA2018&period;1、2017&period;3激活</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em5jyj9.html">jquery一句话实现快速搜索功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql12d4x9.html">进程在Linux内核中的角色扮演</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vxyd5q.html">open-falcon设置报警邮件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx27eod8.html">SQL创建数据库、建表、填入内容</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/390gr2m8.html">&lbrack;jQuery学习系列六&rsqb;6-jQuery实际操作小案例</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql4lwe9.html">Atitit&period;html css &amp;&num;160&semi;浏览器原理理论概论导论attilax总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2457v8.html">paip&period;log4j兼容linux windows 路径设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93zdvwq.html">店商互联（北京）科技发展有限公司DS365&period;com</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql45ek9.html">&lbrack;轉&rsqb;redis&semi;mongodb&semi;memcache三者的性能比較</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7rn0e8.html">架设证书服务器 及 让IIS启用HTTPS服务&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql4vnx9.html">转： sql server2008 字段类型详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93z7egq.html">机器学习技法--学习笔记04--Soft SVM</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zw6z38.html">Ios开发之定位CLLocationManager</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq407xj8.html">javascript 中的getter&comma;setter</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
